
	program UpprSegInf

!	To calculate upper basin area of each segment outlet
!
!	[ Input ]
!	- ToneESN410NEW-mod.con : the output of "makeConnect"
!					the extraceted PF format, **.out -> segment connection data file, **.con
!	- EachArea.out : the output of "SumArea"
!					the data should be listed in one file, 
!					for that, shell script is useful as below.
!					 ./sumArea.exe	../4.edgeUpperArea-2.2/ToneECV5-410.out	>>	EachArea.out
!					 ./sumArea.exe	../4.edgeUpperArea-2.2/ToneECV5-411.out	>>	EachArea.out
!					 ./sumArea.exe	../4.edgeUpperArea-2.2/ToneECV5-412.out	>>	EachArea.out
!
!	[ Output ]
!	- SumArea.out : each segment (sub-basin) number, and its upper basin area
!					==>> 'river width' is able to calculate with this data
!	- SegInfo.out : each segment (sub-basin) number, and its upper segment (sub-basin) number
!
!	## in this program the number "2151" is the total segment number of Tone-Gawa ##
!	## all the input and output files should have the same order of the segment   ##

	integer totalLinkNum
	character*80 conFile, eachAreaFile, sumAreaFile, segInfoFile

!****ȉ parameter ̂Ƃ̒lݒ肵ĂB**************************************
	parameter (totalLinkNum = 2151)   ! <============== ͓敪ԍݒ肷B
	parameter (conFile = 'ToneESN410NEW-mod.con') ! <==íj͓敪ڑ󋵃t@Cݒ肷B
	parameter (eachAreaFile = 'EachArea.out')     ! <==íjPʗʐσt@Cݒ肷B
	parameter (sumAreaFile = 'SumArea.out')       ! <==iój㗬ʐσt@Cݒ肷B
	parameter (segInfoFile = 'SegInfo.out')       ! <==iój㗬͓敪t@Cݒ肷B
!****܂*********************************************************************************

	real segarea(totalLinkNum), sumarea(totalLinkNum)
	integer segnum(totalLinkNum),uppno(totalLinkNum)
	integer up(totalLinkNum,5)
	integer reader(1000), writer(1000)
	character dc*10

	open (0,file=conFile ,status='old')
	read (0,'(///)')
	do i=1, totalLinkNum
	read (0,*) segnum(i), dc, uppno(i)
	enddo
	close(0)

	open (0,file=conFile,status='old')
	read (0,'(///)')
	do i=1, totalLinkNum
	if (uppno(i).eq.0) then
	read (0,*) segnum(i),dc,uppno(i)
	else if (uppno(i).eq.1) then
	read (0,*) segnum(i),dc,uppno(i), dc,up(i,1)
	else if (uppno(i).eq.2) then
	read (0,*) segnum(i),dc,uppno(i), dc,(up(i,j),j=1,2)
	else if (uppno(i).eq.3) then
	read (0,*) segnum(i),dc,uppno(i), dc,(up(i,j),j=1,3)
	else if (uppno(i).eq.4) then
	read (0,*) segnum(i),dc,uppno(i), dc,(up(i,j),j=1,4)
	else if (uppno(i).eq.5) then
	read (0,*) segnum(i),dc,uppno(i), dc,(up(i,j),j=1,5)
	else
	write(*,*) 'more than 5point upper segment happens', uppno(i)
	stop
	endif
	enddo
	close(0)

	open (0,file=eachAreaFile, status='old')
	do i=1, totalLinkNum
	read (0,*) dc, dc, segarea(i)
	enddo
	close(0)

	write(*,*) 'reading the seg-con: done'
!############################################################################
!
	open (0,file=sumAreaFile, status='unknown')
	open (1,file=segInfoFile, status='unknown')

!!!!!!!!!!!!!!!!!!!!!!!
	do i=1, totalLinkNum

	write(1,*) 'Segment Number:', segnum(i)
	sumarea(i) = segarea(i)

	kk=0
	do j=1,5
	 if (up(i,j).gt.0) then
	  kk=kk+1
	  writer(kk) = up(i,j)
	 endif
	enddo

 9	do jj=1,kk
	 write(1,*) writer(jj)
	do ii=1,2151
	 if (writer(jj).eq.segnum(ii)) then
	 sumarea(i) = sumarea(i)+segarea(ii)
	  do j=1,5
	  reader((jj-1)*5+j) = up(ii,j)
	  enddo
	 endif
	enddo
	enddo

	kkk=0
	do k=1,kk*5
	 if (reader(k).gt.0) then
	  kkk=kkk+1
	  writer(kkk) = reader(k)
	 endif
	enddo

	if (kkk.ne.0) then
	 kk=kkk
	 goto 9
	endif
	
	write(1,*) 'Total Area:', sumarea(i)/(10.0**6.0)
	write(0,*) segnum(i),sumarea(i)/(10.0**6.0)
	write(*,*) 'seg-con writing  ', i,' / 2151' 
	enddo
!!!!!!!!!!!!!!!!!!!!!!!
	
	close(0)
	close(1)
	stop
	end




